Unit Unit1;
Interface
Uses Windows, Messages, SysUtils, Variants, Classes,
  Graphics, Controls, Forms, Dialogs, ExtCtrls, StdCtrls;

Const
  HookDll = 'HOOKDLL.DLL';

Type
  TProcCallBack = Procedure(Msg: Integer); STDCALL;
  TForm1 = Class(TForm)
    Procedure FormDestroy(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    Procedure OnWmCopyData(Var msg: TMessage); MESSAGE WM_COPYDATA;
  End;
  TKeyState = Record
    ExtendedKey, Ctrl, Alt, PrevPressed, Pressed: Boolean;
  End;

Var
  Form1: TForm1;
  MouseHookStruct: TMouseHookStruct;

Procedure FinalisationHook; STDCALL; EXTERNAL HookDll;
Function InitialisationHook(HandelDestData: HWnd): Boolean; STDCALL; EXTERNAL HookDll;
Function GetEtatTouche(from: Integer): TKeyState;


{----------------------------------------------------------------}
{                       }Implementation{                         }
{----------------------------------------------------------------}
{$R *.DFM}

Type
  TPDataEnvoyes = ^TDataEnvoyes;
  TDataEnvoyes = Packed Record
    Key: WPARAM;
    State: LPARAM
  End;

Var
  EtatKb : Array [0..255] Of Boolean;


{----------------------------------------------------------------}
Function bit(bitnum, int: Integer): Boolean;
Begin
  Result := (int And (Cardinal(1) Shl (bitnum - 1))) > 0;
End;

{----------------------------------------------------------------}
Function GetEtatTouche(from: Integer): TKeyState;
Begin
  Result.Pressed := Not bit(32, from);
  Result.PrevPressed := bit(31, from);
  Result.Alt := bit(30, from);
  Result.ExtendedKey := bit(25, from);
End;


{----------------------------------------------------------------}
{ KEYBOARD INTERRUPT                                             }
{----------------------------------------------------------------}
Procedure TForm1.OnWmCopyData(Var msg: TMessage);

Type
  TPCopyDataStruct = ^TCopyDataStruct;
  TPDataEnvoyes = ^TDataEnvoyes;

Var
  DataEnvoyes: TDataEnvoyes;
  PDataEnvoyes: TPDataEnvoyes;
  PCopyDataStruct: TPCopyDataStruct;
  KeyState: TKeyState;
  passkey: Integer;

Begin
  PCopyDataStruct := TPCopyDataStruct(msg.LParam);
  PDataEnvoyes := PCopyDataStruct^.lpData;
  DataEnvoyes := PDataEnvoyes^;
  KeyState := GetEtatTouche(DataEnvoyes.State);
  PassKey := DataEnvoyes.State;
  EtatKb[DataEnvoyes.Key] :=  KeyState.Pressed;
  msg.Result := 1;
  If (EtatKb[VK_F1]) Then msg.Result := 0;
End;



{----------------------------------------------------------------}
{ FORM DESTROY                                                   }
{----------------------------------------------------------------}
Procedure TForm1.FormDestroy(Sender: TObject);
Begin
  FinalisationHook;
End;


{----------------------------------------------------------------}
{ FORM CREATE                                                    }
{----------------------------------------------------------------}
Procedure TForm1.FormCreate(Sender: TObject);
Begin
  FinalisationHook;
  If Not (InitialisationHook(Handle)) Then
  Begin
    ShowMessage('Erreur  la cration du Hook!');
    HALT;
  End;
End;
          

{----------------------------------------------------------------}
End.

